#include "cdictionaryinttoint.h"
#include <gtest/gtest.h>
CDictionaryIntToInt testme;

TEST(CDictionaryIntToInt, init) {
    CDictionaryIntToInt testme(2,10);
    ASSERT_EQ(testme.get(2),10);
    EXPECT_EQ(testme.gettotal(),1);
    CDictionaryIntToInt testmemore=testme;
    ASSERT_EQ(testmemore.get(2),10);
    EXPECT_EQ(testmemore.gettotal(),1);
}

TEST(CDictionaryIntToInt, eq) {
    CDictionaryIntToInt testme2;
    EXPECT_TRUE(testme==testme2);
    testme.add(5,90);
    EXPECT_FALSE(testme==testme2);
    EXPECT_EQ(testme.gettotal(),1);
    testme.add(25,-60);
    testme2.add(25,-60);
    testme2.add(5,90);
    EXPECT_TRUE(testme==testme2);
}

TEST(CDictionaryIntToInt, addingCopyingAndRemoving) {
    EXPECT_EQ(testme.gettotal(),2);
    EXPECT_EQ(testme.get(5),90);
    EXPECT_FALSE(testme.add(5,20));
    EXPECT_EQ(testme.get(25),-60);
    EXPECT_EQ(testme.gettotal(),2);
    CDictionaryIntToInt testmemore(testme);
    EXPECT_EQ(testme.gettotal(),2);
    EXPECT_EQ(testmemore.get(5),90);
    EXPECT_EQ(testmemore.get(25),-60);
}

TEST(CDictionaryIntToInt, summingAndsubtraction) {
    CDictionaryIntToInt testmemore;
    CDictionaryIntToInt horrible=testme+testmemore;
    EXPECT_EQ(horrible.get(5),90);
    EXPECT_EQ(horrible.get(25),-60);
    horrible=testmemore+testme;
    EXPECT_EQ(horrible.gettotal(),2);
    EXPECT_EQ(horrible.get(5),90);
    EXPECT_EQ(horrible.get(25),-60);
    horrible.add(9,0);
    horrible=horrible-testme;
    EXPECT_EQ(horrible.gettotal(),1);
    CDictionaryIntToInt horribleclone(horrible);
    EXPECT_EQ((horrible-horribleclone).gettotal(),0);
    EXPECT_EQ((horrible-testmemore).gettotal(),1);
    EXPECT_EQ((testmemore-horrible).gettotal(),0);
}

TEST(CDictionaryIntToInt, overlap){
    CDictionaryIntToInt iam25_minus60(25,-60);
    EXPECT_TRUE((testme/iam25_minus60)==iam25_minus60);
    EXPECT_TRUE((iam25_minus60/testme)==iam25_minus60);
}

TEST(CDictionaryIntToIntTest, CopyAndMove) {
    CDictionaryIntToInt test(1,2);
    test.add(52,10);
    CDictionaryIntToInt copy(test);
    EXPECT_TRUE(test==copy);
    CDictionaryIntToInt moved(std::move(test));
    EXPECT_EQ(moved.gettotal(),2);
    EXPECT_EQ(test.gettotal(),0);
}
